Search documentation of stripe_elixir

# StripeElixir.Params.SubscriptionUpdateParams (stripe_elixir v0.1.0)

Copy Markdown View Source

Parameters for subscription update.

## Summary

### Types

t()

## Types

# t()

    @type t() :: %StripeElixir.Params.SubscriptionUpdateParams{
      add_invoice_items: [map()] | nil,
      application_fee_percent: map() | nil,
      automatic_tax: map() | nil,
      billing_cycle_anchor: String.t() | nil,
      billing_thresholds: map() | nil,
      cancel_at: map() | nil,
      cancel_at_period_end: boolean() | nil,
      cancellation_details: map() | nil,
      collection_method: String.t() | nil,
      days_until_due: integer() | nil,
      default_payment_method: String.t() | nil,
      default_source: map() | nil,
      default_tax_rates: map() | nil,
      description: map() | nil,
      discounts: map() | nil,
      expand: [String.t()] | nil,
      invoice_settings: map() | nil,
      items: [map()] | nil,
      metadata: map() | nil,
      off_session: boolean() | nil,
      on_behalf_of: map() | nil,
      pause_collection: map() | nil,
      payment_behavior: String.t() | nil,
      payment_settings: map() | nil,
      pending_invoice_item_interval: map() | nil,
      proration_behavior: String.t() | nil,
      proration_date: integer() | nil,
      transfer_data: map() | nil,
      trial_end: map() | nil,
      trial_from_plan: boolean() | nil,
      trial_settings: map() | nil
    }

- `add_invoice_items` - A list of prices and quantities that will generate invoice items appended to the next invoice for this subscription. You may pass up to 20 items.
- `application_fee_percent` - A non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice total that will be transferred to the application owner's Stripe account. The request must be made by a platform account on a connected account in order to set an application fee percentage. For more information, see the application fees documentation.
- `automatic_tax` - Automatic tax settings for this subscription. We recommend you only include this parameter when the existing value is being changed.
- `billing_cycle_anchor` - Either `now` or `unchanged`. Setting the value to `now` resets the subscription's billing cycle anchor to the current time (in UTC). For more information, see the billing cycle documentation. Possible values: `now`, `unchanged`. Max length: 5000.
- `billing_thresholds` - Define thresholds at which an invoice will be sent, and the subscription advanced to a new billing period. When updating, pass an empty string to remove previously-defined thresholds.
- `cancel_at` - A timestamp at which the subscription should cancel. If set to a date before the current period ends, this will cause a proration if prorations have been enabled using `proration_behavior`. If set during a future period, this will always cause a proration for that period.
- `cancel_at_period_end` - Indicate whether this subscription should cancel at the end of the current period (`current_period_end`). Defaults to `false`.
- `cancellation_details` - Details about why this subscription was cancelled
- `collection_method` - Either `charge_automatically`, or `send_invoice`. When charging automatically, Stripe will attempt to pay this subscription at the end of the cycle using the default source attached to the customer. When sending an invoice, Stripe will email your customer an invoice with payment instructions and mark the subscription as `active`. Defaults to `charge_automatically`. Possible values: `charge_automatically`, `send_invoice`.
- `days_until_due` - Number of days a customer has to pay invoices generated by this subscription. Valid only for subscriptions where `collection_method` is set to `send_invoice`.
- `default_payment_method` - ID of the default payment method for the subscription. It must belong to the customer associated with the subscription. This takes precedence over `default_source`. If neither are set, invoices will use the customer's invoice_settings.default_payment_method or default_source. Max length: 5000.
- `default_source` - ID of the default payment source for the subscription. It must belong to the customer associated with the subscription and be in a chargeable state. If `default_payment_method` is also set, `default_payment_method` will take precedence. If neither are set, invoices will use the customer's invoice_settings.default_payment_method or default_source.
- `default_tax_rates` - The tax rates that will apply to any subscription item that does not have `tax_rates` set. Invoices created will have their `default_tax_rates` populated from the subscription. Pass an empty string to remove previously-defined tax rates.
- `description` - The subscription's description, meant to be displayable to the customer. Use this field to optionally store an explanation of the subscription for rendering in Stripe surfaces and certain local payment methods UIs.
- `discounts` - The coupons to redeem into discounts for the subscription. If not specified or empty, inherits the discount from the subscription's customer.
- `expand` - Specifies which fields in the response should be expanded.
- `invoice_settings` - All invoices will be billed using the specified settings.
- `items` - A list of up to 20 subscription items, each with an attached price.
- `metadata` - Set of key-value pairs that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to `metadata`.
- `off_session` - Indicates if a customer is on or off-session while an invoice payment is attempted. Defaults to `false` (on-session).
- `on_behalf_of` - The account on behalf of which to charge, for each of the subscription's invoices.
- `pause_collection` - If specified, payment collection for this subscription will be paused. Note that the subscription status will be unchanged and will not be updated to `paused`. Learn more about pausing collection.
- `payment_behavior` - Use `allow_incomplete` to transition the subscription to `status=past_due` if a payment is required but cannot be paid. This allows you to manage scenarios where additional user actions are needed to pay a subscription's invoice. For example, SCA regulation may require 3DS authentication to complete payment. See the SCA Migration Guide for Billing to learn more. This is the default behavior.

Use `default_incomplete` to transition the subscription to `status=past_due` when payment is required and await explicit confirmation of the invoice's payment intent. This allows simpler management of scenarios where additional user actions are needed to pay a subscription’s invoice. Such as failed payments, SCA regulation, or collecting a mandate for a bank debit payment method.

Use `pending_if_incomplete` to update the subscription using pending updates. When you use `pending_if_incomplete` you can only pass the parameters supported by pending updates.

Use `error_if_incomplete` if you want Stripe to return an HTTP 402 status code if a subscription's invoice cannot be paid. For example, if a payment method requires 3DS authentication due to SCA regulation and further user action is needed, this parameter does not update the subscription and returns an error instead. This was the default behavior for API versions prior to 2019-03-14. See the changelog to learn more. Possible values: `allow_incomplete`, `default_incomplete`, `error_if_incomplete`, `pending_if_incomplete`.

- `payment_settings` - Payment settings to pass to invoices created by the subscription.
- `pending_invoice_item_interval` - Specifies an interval for how often to bill for any pending invoice items. It is analogous to calling Create an invoice for the given subscription at the specified interval.
- `proration_behavior` - Determines how to handle prorations when the billing cycle changes (e.g., when switching plans, resetting `billing_cycle_anchor=now`, or starting a trial), or if an item's `quantity` changes. The default value is `create_prorations`. Possible values: `always_invoice`, `create_prorations`, `none`.
- `proration_date` - If set, prorations will be calculated as though the subscription was updated at the given time. This can be used to apply exactly the same prorations that were previewed with the create preview endpoint. `proration_date` can also be used to implement custom proration logic, such as prorating by day instead of by second, by providing the time that you wish to use for proration calculations. Format: Unix timestamp.
- `transfer_data` - If specified, the funds from the subscription's invoices will be transferred to the destination and the ID of the resulting transfers will be found on the resulting charges. This will be unset if you POST an empty value.
- `trial_end` - Unix timestamp representing the end of the trial period the customer will get before being charged for the first time. This will always overwrite any trials that might apply via a subscribed plan. If set, `trial_end` will override the default trial period of the plan the customer is being subscribed to. The `billing_cycle_anchor` will be updated to the `trial_end` value. The special value `now` can be provided to end the customer's trial immediately. Can be at most two years from `billing_cycle_anchor`.
- `trial_from_plan` - Indicates if a plan's `trial_period_days` should be applied to the subscription. Setting `trial_end` per subscription is preferred, and this defaults to `false`. Setting this flag to `true` together with `trial_end` is not allowed. See Using trial periods on subscriptions to learn more.
- `trial_settings` - Settings related to subscription trials.